﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using System.IO;
using HeuristicLab.PluginInfrastructure.Manager;
using ICSharpCode.SharpZipLib.Zip;

namespace HeuristicLab.Update.Service {
  public class UpdateLocation : IUpdateLocation {

    #region IUpdateLocation Members

    public IEnumerable<PluginInformation> GetAvailablePlugins() {
      yield break;
    }

    public System.IO.Stream GetPackedPlugin(PluginInformation info) {
      MemoryStream memStream = new MemoryStream();
      ZipOutputStream stream = new ZipOutputStream(memStream);
      ZipEntryFactory fac = new ZipEntryFactory();
      foreach (string fileName in GetMatchingPluginDescription(info.Name, pluginManager.Plugins).Files) {
        stream.PutNextEntry( (Path.Combine(pluginDir, fileName)));
      }

      return memStream;
    }

    private static PluginDescription GetMatchingPluginDescription(string name, IEnumerable<PluginDescription> plugins) {
      return (from x in plugins
              where x.Name == name
              select x).Single();
    }

    #endregion
  }
}
